#pragma once

#include "ofMain.h"
#include "ofEvents.h"
#include "ofTrueTypeFont.h"
//#include "ofGraphics.h"

class ofApp : public ofBaseApp{

         public:

                void setup();
                void update();
                void draw();

                void keyPressed(int key);
                void keyReleased(int key);
                void mouseMoved(int x, int y );
                void mouseDragged(int x, int y, int button);
                void mousePressed(int x, int y, int button);
                void mouseReleased(int x, int y, int button);
                void mouseEntered(int x, int y);
                void mouseExited(int x, int y);
                void windowResized(int w, int h);
                void dragEvent(ofDragInfo dragInfo);
                void gotMessage(ofMessage msg);

                void getCalc(int, int, int, int, int, int);
                void moveToTarget();
                void updateScreen();
                void trim(int, int);
                void delay(double);


                ofVideoGrabber 	vidGrabber;
                ofPixels        outPixels;
                ofTexture       videoTexture;
                ofArduino       arduino;        //Pins: 3: left-right. 10: up-down. 9: forward-backwards.
                ofTrueTypeFont  font;

                int             camWidth;
                int             camHeight;

                float           oldTime;

            // For selecting Colors
                int             gaugeColor[3] = {0, 255, 0};    //Alternative values: 0|102|0
                int             gaugeColor2[3] = {255, 55, 0};                     // 190|0|0
                int             cCounter;

            // For locating signal lights
                int             greenCenter[2] = {0};
                int             redCenter[2] = {0, 0};
                float             center [2] = {0, 0};
                int             distance[2] = {0};
                float             oldPosX = 0;
                float             oldPosY = 0;

            // Booleans
                bool            bOutOfPerimeter;
                bool            bPause = TRUE;
                bool            bSetupArduino;
                bool            bTrim;

            // Movement
                int             trimDistX = 0;
                int             trimDistY = 0;
                short           trimX = 127;
                short           trimY = 127;
                short           pwmZ = 0;
                short           pwmV = 0;
                short           pwmX = 0;
                short           pwmY = 0;
                float           optimalDistance = 24;
                float           currentDistance;
                float           oldDistance;
                float           height = 0;

                float           p1 = 0.42; // High-mode
                float           p2 = 0.55;

                float           p1V = 200; //adjustVert
                float           p2V = 10;

                ushort          target[2] = {0};
                float           targetDist[2] = {0};    //Target coordinates in 2nd (copter-)system | Array with x and y.

                double          coAngle;

        private:
                void setupArduino(const int & version);
};

